class Strongspace.Models.Session extends Backbone.Model

	defaults:
		name: ""


	initialize: ->
		if @get('driveName')
			@set('name', @get('driveName'))
			@set('driveName', null)


	uniqueId: (length=8) ->
		id = ""
		id += Math.random().toString(36).substr(2) while id.length < length
		id.substr 0, length
		return id

	start: ->
		password = $("#password").val()

		if password == undefined or password == ""
			password = keychain.get(@get('server'), @get('username'), @get('type'), @get('port'), @get('password')) 
		@password = password
		expandrive.startDrive(@.id, JSON.stringify(@attributes), password)

	reveal: ->
		expandrive.revealDrive(@mountpoint)
	
	eject: ->
		expandrive.ejectDrive(@.id)

	stop: ->
		expandrive.ejectDrive(@.id)

	activity: (s) ->
		self = @
		if s.indexOf("EXPANDRIVE_CONNECT_PROGRESS:drive_connected") != -1
			if settings.getBool("ShowDesktopNotifications")
				growl.postNotification("Connected", "ExpanDrive | " + @get("name"))
			
			setTimeout ( ->
				if settings.getBool("RevealAfterConnect")
					self.reveal()
			), 1000
			
			@set('status', 'connected')
			Strongspace.List.render()

		if s.indexOf("EXPANDRIVE_AUTH_PASSWORD:") != -1
			if @password == null or @password == "" or @password == undefined
				self = @
				
				setTimeout ( ->
					if self.private_key 
						expandrive.passwordPrompt(self.id, "Password for " + s.substring(s.lastIndexOf("\\")+1) + ":")
					else
						expandrive.passwordPrompt(self.id, "Password for " + s.split(":")[1])
				), 10
			else
				expandrive.writeLine(@.id, @password)
			@password = null
		
		if s.indexOf("EXPANDRIVE_AUTH_PRIVATEKEY_FILE") != -1
			@.private_key = true
			expandrive.writeLine(@.id, @get('private_key_file'))

		if s.indexOf("EXPANDRIVE_AUTH_USERNAME:") != -1
			self = @
			setTimeout ( ->
				expandrive.inputPrompt(self.id, "Please enter a username")
			), 10
			
		if s.indexOf("EXPANDRIVE_GET_CONFIG:volicon_path") != -1
			expandrive.writeLine(@.id, "")

		if s.indexOf("EXPANDRIVE_CLAIM_MOUNTPOINT") != -1
			@mountpoint = s.split(":")[2]

		if s.indexOf("EXPANDRIVE_CONNECT_FAILURE") != -1
			alert "Could not connect to #{@get('server')}:\n#{s.split(":")[1]}"

		if s.indexOf("EXPANDRIVE_CONNECT_PROGRESS:connecting") != -1
			@set('status', 'connecting')
			Strongspace.List.render()

		if s.indexOf("EXPANDRIVE_RELEASE_MOUNTPOINT") != -1 or s.indexOf("EXPANDRIVE_TASK_COMPLETED") != -1  
			@set('status', null)
			Strongspace.List.render()

		if s.indexOf("STRONGSYNC:ACTIVITYGROWL") != -1
			pieces = s.split(":")
			if settings.getBool("ShowDesktopNotifications")
				growl.postNotification(pieces[2], pieces[3])


	cleanJSON: ->
		r = @toJSON()
		delete r['status']
		delete r['info']
		delete r['url']
		delete r['path']
		delete r['driveName']
		delete r['driveType']
		return r

	error: (s) ->
		alert s

	info: ->

		if @get('status') == "connecting"
			return "Connecting..."

		if @get('info')
			return @get('info')
			
		return @url()

	mountpoint_label: ->
		if @mountpoint != undefined and @get('status') == "connected" and settings.platform() != "mac"
			return "(" + @mountpoint + ":) "

	url: ->
		u = ''

		if @get('type') == 's3'
		 	u = 's3.amazonaws.com'

 		if @get('type') == 'Strongspace'
		 	u = @get('username') + '.strongspace.com'

		if @get('server')
			u =  @get('server') 

		if @get('remotePath')
			u += " - " + @get('remotePath')
		return u


	classes: ->
		if @get('status') == "connected"
			classes_string = " connected "

		if @get('status') == "connecting"
			classes_string = " connecting "

		return classes_string

