class Strongspace.Views.Details extends Backbone.View
	
	initialize: ->
		dlog "init"

	

	afterRender: (view) ->

		$("#type").val(@serialize['session'].get("type"))
		
		if @serialize['session'].get('password') or @serialize['session'].get('id') == undefined or $("#password").val() != ""
			$("#save_password").prop('checked', true)

		if @serialize['session'].get('reconnectAtLogon') == true
			$("#reconnect_at_logon").prop('checked', true)
		
		if @serialize['session'].get("mountpoint")
			$("#mountpoint").val(@serialize['session'].get("mountpoint"))
		
		if @serialize['session'].get("authentication")
			$("#authentication").val(@serialize['session'].get("authentication"))
			
			if($("#authentication").val() != "password")
				$("#password").html("").prop("disabled", true)
			else
				$("#password").prop("disabled", null)

		if !$("#more_options").is(":visible") and Strongspace.Settings['more_options'] == true
			$("#more_options").show()
			$("#button_fewer_options").show()
			$("#button_more_options").hide()

		if @serialize['session'].get('status') == "connected" or @serialize['session'].get('status') == "connecting"
			$("#details input, #details select").prop('disabled', true)

		if settings.platform() == "mac"
			$(".platform_windows").remove()

		@changeDriveType()

	events:
		"click #button_connect" : "connectSession"
		"click #button_delete" : "deleteSession"
		"click #button_reveal" : "revealSession"
		"click #button_eject" : "ejectSession"
		"click #button_add_favorite" : "addFavorite"
		"click #button_save" : "saveSession"
		"click #button_more_options" : "toggleMoreOptions"
		"click #button_fewer_options" : "toggleMoreOptions"

		"keydown input" : "unhideSaveChanges"
		"change #type" : "changeDriveType"
		"change #mountpoint" : "unhideSaveChanges"
		"change #reconnect_at_logon" : "unhideSaveChanges"
		"change #save_password" : "unhideSaveChanges"
		"change #authentication" : "promptForKey"

	tagName: "div"

	id: "page_sessiondetails"


	unhideSaveChanges: (event) ->
		if !event.shiftKey and !event.altKey and !event.metaKey
			if not $("#button_add_favorite").is(":visible")
				$("#button_save,#button_add_favorite").show(200)


	addFavorite: (event) ->
		event.preventDefault()
		
		if $("#server").val() == "" and $("#type").val() != "s3"
			return

		session = new Strongspace.Models.Session()


		session.set('server', $("#server").val())

		session.set('remotePath', $("#remotePath").val())
		session.set('port', $("#port").val())
		session.set('name', $("#server").val())
		
		if $("#type").val() == "s3"
			session.set("name", "Amazon S3")

		session.set('authentication', $("#authentication").val())

		if($("#authentication").val() == "publickey")
			session.set("private_key_file", @serialize['session'].get("private_key_file"))

		session.set('username', $("#username").val())
		session.set('type', $("#type").val())
		if $("#name").val()
			session.set('name', $("#name").val())
		session.set('mountpoint', $("#mountpoint").val())
		session.set('reconnectAtLogon', $("#reconnect_at_logon").prop('checked') == true)
		
		if $("#save_password").prop("checked") == true
			encrypted = keychain.save(@$("#server").val(), @$("#username").val(), @$("#password").val(), session.get("type"), session.get("port"))
			if encrypted and encrypted.length
				session.set('password', encrypted)
		else
			session.set('password', null)
			session.password = null
			$("#password").html("")

		session.save()

		Strongspace.SavedSessions.add(session)
		$("li.favorites").click()
		dlog "Add"
		Strongspace.List.selectSession(session.id)

	saveSession: (event) ->
		event.preventDefault()

		if $("#server").val() == "" and $("#type").val() != "s3"
			return

		session = @serialize['session']

		session.set('server', $("#server").val())
		session.set('remotePath', $("#remotePath").val())
		session.set('port', $("#port").val())
		session.set('name', $("#server").val())
		if $("#type").val() == "s3"
			session.set("name", "Amazon S3")
		session.set('authentication', $("#authentication").val())
		session.set('username', $("#username").val())
		session.set('type', $("#type").val())
		if $("#name").val()
			@serialize['session'].set('name', $("#name").val())
		session.set('mountpoint', $("#mountpoint").val())
		session.set('reconnectAtLogon', $("#reconnect_at_logon").prop('checked') == true)

		if $("#save_password").prop("checked") == true
			encrypted = keychain.save(@$("#server").val(), @$("#username").val(), @$("#password").val(), session.get("type"), session.get("port"))
			if encrypted and encrypted.length
				session.set('password', encrypted)
		else
			session.set('password', null)
			session.password = null
			$("#password").html("")

		session.save()
		Strongspace.List.render()
		Strongspace.List.selectSession(session.id)

	revealSession: (event) ->
		event.preventDefault()
		@serialize['session'].reveal()

	ejectSession: (event) ->
		event.preventDefault()
		@serialize['session'].eject()

	connectSession: (event) ->
		event.preventDefault()

		if @serialize['session'].id == undefined or @serialize['session'].id.length == 0
			@addFavorite(event)

		@serialize['session'].start()

	deleteSession: (event) ->
		event.preventDefault()
		session = @serialize['session']
		session.stop()
		Strongspace.SavedSessions.remove(session)
		session.destroy()
		Strongspace.List.render()


	toggleMoreOptions: (event) ->
		dlog Strongspace.Settings['more_options']
		Strongspace.Settings['more_options'] = !Strongspace.Settings['more_options']
		$("#more_options").toggle(200)
		$("#button_fewer_options").toggle()
		$("#button_more_options").toggle()

	promptForKey: (event) ->
		@unhideSaveChanges(event)
		if $("#authentication").val() == "publickey"
			expandrive.keyPrompt("key", "Please select your private key")
			$("#password").html("").prop("disabled", true)
			@serialize['session'].set('private_key_file', expandrive.privateKeyData())
		else if $("#authentication").val() == "password"
			$("#password").prop("disabled", null)




	changeDriveType: (event) ->

		$("label", $("#username").parents(".control-group") ).html("Username:")
		$("label", $("#password").parents(".control-group") ).html("Password:")
		$("#port").parents(".control-group").show()
		$("#authentication").parents(".control-group").show()
		if @serialize['session'].get('status') != "connected" and @serialize['session'].get('status') != "connecting"
			$("#server").prop("disabled", false)
		$("#server").attr("placeholder", null)


		if($("#type").val() == "sftp")
			$("#port").attr("placeholder", 22)

		if($("#type").val() == "ftp")
			$("#port").attr("placeholder", 21)
			$("#authentication").parents(".control-group").hide()

		if($("#type").val() == "s3")
			$("#server").prop("disabled", true).attr("placeholder", "s3.amazonaws.com").val("")
			$("label", $("#username").parents(".control-group") ).html("Access ID:")
			$("label", $("#password").parents(".control-group") ).html("Secret Key:")
			$("#port").parents(".control-group").hide()
			$("#authentication").parents(".control-group").hide()
